/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package administrationservice;

import com.heuristiclab.services.administration.AdministrationService;
import com.heuristiclab.services.administration.Algorithm;
import com.heuristiclab.services.administration.ArrayOfAlgorithm;
import com.heuristiclab.services.administration.ArrayOfPlatform;
import com.heuristiclab.services.administration.IAdministrationService;
import com.heuristiclab.services.administration.ObjectFactory;
import com.heuristiclab.services.administration.Platform;
import java.net.MalformedURLException;
import java.net.URL;
import java.security.KeyManagementException;
import java.security.NoSuchAlgorithmException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.net.ssl.HttpsURLConnection;
import javax.net.ssl.SSLContext;
import javax.net.ssl.TrustManager;
import javax.net.ssl.X509TrustManager;
import javax.xml.bind.JAXBElement;

/**
 *
 * @author MartinH
 */
public class Main {


    	static {
		// Create a trust manager that does not validate certificate chains
		TrustManager[] trustAllCerts = new TrustManager[] { new X509TrustManager() {
			public java.security.cert.X509Certificate[] getAcceptedIssuers() {
				return new java.security.cert.X509Certificate[] {};
			}

			public void checkClientTrusted(
					java.security.cert.X509Certificate[] certs, String authType) {
			}

			public void checkServerTrusted(
					java.security.cert.X509Certificate[] certs, String authType) {
			}
		} };

		SSLContext sc;
		try {
			sc = SSLContext.getInstance("SSL");
			sc.init(null, trustAllCerts, new java.security.SecureRandom());
			HttpsURLConnection
					.setDefaultSSLSocketFactory(sc.getSocketFactory());
		} catch (NoSuchAlgorithmException e) {
			throw new RuntimeException(e);
		} catch (KeyManagementException e) {
			throw new RuntimeException(e);
		}

	}

	public void GetAlgorithmsTest(IAdministrationService port) {

		ArrayOfAlgorithm algos = port.getAlgorithms();


		for (Algorithm algo : algos.getAlgorithm()) {
			System.out.println("algo ClassId:=" + algo.getAlgorithmClassId());
			System.out.println("algo Id:=" + algo.getId());
			System.out.println("algo PlattformId:=" + algo.getPlatformId());
			System.out.println("algo Class:=" + algo.getClass());
			System.out.println("algo Description:="
					+ algo.getDescription().getValue());
			System.out.println("algo Name:=" + algo.getName().getValue());
		}
		//assertTrue("No Algorithms found!", algos.getAlgorithm().size() > 0);
	}

	public void GetPlatformsTest(IAdministrationService port) {

		ArrayOfPlatform algos = port.getPlatforms();


		for (Platform platform : algos.getPlatform()) {
			System.out.println("platform Id:=" + platform.getId());
			System.out.println("platform Class:=" + platform.getClass());
			System.out.println("platform Description:="
					+ platform.getDescription().getValue());
			System.out.println("platform Name:=" + platform.getName().getValue());
		}
		//assertTrue("No Platforms found!", algos.getPlatform().size() > 0);
	}

	public void AddPlatformsTest(IAdministrationService port) {
                Long retval = 0L;
                ObjectFactory fac = new ObjectFactory();
                Platform p = fac.createPlatform();
                p.setName(fac.createNamedOKBItemName("ECJ"));
                p.setDescription(fac.createNamedOKBItemDescription("A Java-based Evolutionary Computation Research System"));


                try {
                    retval = port.addPlatform(p);
                } catch (Exception e) {
                    e.printStackTrace();
                }

                System.out.println("adding of Platform "+(retval>0?"sucessful":"failed"));
	}


    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        try {
            Main test = new Main();
            AdministrationService srv = new AdministrationService(new URL("https://services.heuristiclab.com/OKB.SPR.Java-3.3/AdministrationService.svc?wsdl"));
            IAdministrationService port = srv.getAdministrationService();
            test.GetAlgorithmsTest(port);
            test.AddPlatformsTest(port);
            test.GetPlatformsTest(port);
        } catch (MalformedURLException ex) {
            Logger.getLogger(Main.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

}
